AJS.$(document).ready( function() {
	
	if (document.location.href.indexOf('JEMHTestCaseProjectTab')==-1)
	{
		console.log('JEMH Project : quiting project-testcase.js early due to JRA-32379');
		return;
	}
	else
	{
		console.log("JEMH Project : project-testcase.js loaded");	
	}
	
	var lastAuditHistoryEventLoaded=0;
	var IMAGE_BASE=AJS.params.baseURL+'/download/resources/com.javahollic.jira.jemh-ui:jemh-images/icons';
	var projectKey=AJS.$('[name=projectKey]').attr('content');
	
	AJS.$(this).find('.jemh-testcase-options').hide();
	AJS.$(".jemh-testcase-row").each(function() {
		AJS.$( this ).hover(
		  function () {
		    AJS.$(this).css("background","#f0f0f0");
		    AJS.$(this).find('.jemh-testcase-options').show();
		  },
		  function () {
		    AJS.$(this).css("background","");
		    AJS.$(this).find('.jemh-testcase-options').hide();
		  }
		);
	});
	
	// background update using REST -- related-issue_$aTestCase.getID()
	AJS.$(".testcase-related-issue").each(function(i, obj) {
		var theId=this.id;	
		var splitVar=theId.split("_");
		var testCaseId=splitVar[1];

		AJS.$.get(AJS.params.baseURL+"/rest/jemh/latest/project/testcase/relatedIssue/"+projectKey+"/"+testCaseId, function(data) {
			if (! data.error && data.issueKey) {
				console.log("matched test case "+testCaseId+" with existing issue: "+data.issueKey);
				AJS.$("#"+theId).addClass('aui-lozenge-current').text(data.issueKey).show();
				AJS.$("#"+theId).parent("a").attr('href',AJS.params.baseURL+'/browse/'+data.issueKey);
			} else {
				AJS.$("#"+theId).text("no issue").show();
			}
		});
	});
	
	AJS.$('.related-issue-link').click(function(event) {
		if (this.href.indexOf("#", this.href.length - 1) !== -1) {
			event.preventDefault();
		} else {
			var win = window.open(this.href, '_blank');
			win.focus();
		}
	});
	
	AJS.$("#jemhTestCaseFilterForm").change(function() {
		console.log('applying filter');

		var formUrl = AJS.$('#jemhTestCaseFilterForm').attr('action');
		var selectedProfileId = AJS.$('#filterByProfile option:selected').val();
		document.location=formUrl+"&projectKey="+projectKey+"&filterByProfile="+selectedProfileId;
	});


	AJS.$("#project-test-case-run-button").on("click", function() {

		var projectTestCaseReportSuccess = document.getElementById('#project-test-case-container');

		if (projectTestCaseReportSuccess === true) {
			AJS.$('#project-test-case-app').attr("hidden", false);
			AJS.$('#jemh-testcase-rows-id').attr("hidden", true);
			AJS.$('#jemhTestCaseFilterForm').attr("hidden", true);
			AJS.$('#jemh-testcase-modify-id').attr("hidden", true);
		}
	});


	AJS.$("#createProjectTestCaseButton").on("click", function () {
		showIfTestCaseExist();
	});

	AJS.$("#deleteAllProjectTestCaseButton").on("click", function () {
		showIfTestCaseExist();
	});

	function showIfTestCaseExist() {
		var projectTestCase = AJS.$("#project-test-case-id").val();

		if (projectTestCase !== null && projectTestCase !== undefined && projectTestCase !== "") {
			AJS.$("#jemh-testcase-rows-id").attr("hidden", false);
			AJS.$("#jemhTestCaseFilterForm").attr("hidden", false);
		} else {
			AJS.$("#jemh-testcase-rows-id").attr("hidden", true);
			AJS.$("#jemhTestCaseFilterForm").attr("hidden", true);
		}
	}
	showIfTestCaseExist();
});