AJS.$(document).ready( function(){
    var atlToken = AJS.$('meta[name="atlassian-token"]').attr('content');
	function hookFromAndReplyToCustomFieldSelects() {
		//sender address
		AJS.$("#customFromAddrCf").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-sender-address-group").show();
			}
			else
			{
				AJS.$(".static-sender-address-group").hide();
			}
		});
		if (AJS.$("#customFromAddrCf").val()=="" || AJS.$("#customFromAddrCf").val()=="0") {
			AJS.$(".static-sender-address-group").show();
		} else {
			AJS.$(".static-sender-address-group").hide();
		}

		//sender personal
		AJS.$("#customFromPersonalCf").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-sender-personal-group").show();
			}
			else
			{
				AJS.$(".static-sender-personal-group").hide();
			}
		});
		
		if (AJS.$("#customFromPersonalCf").val()=="" || AJS.$("#customFromPersonalCf").val()=="0") {
			AJS.$(".static-sender-personal-group").show();
		} else {
			AJS.$(".static-sender-personal-group").hide();
		}
		
		// use system defined sender personal
		AJS.$("#useSystemFromPersonal").change(function(){
			if (AJS.$(this).is(":checked"))
			{
				AJS.$(".jemh-personal-group").hide();
			}
			else
			{
				AJS.$(".jemh-personal-group").show();
			}
		});
		
		if (AJS.$("#useSystemFromPersonal").is(":checked")) {
			AJS.$(".jemh-personal-group").hide();
		} else {
			AJS.$(".jemh-personal-group").show();
		}

		//reply-to address
		AJS.$("#customReplyToAddrCf").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-reply-to-address-group").show();
			}
			else
			{
				AJS.$(".static-reply-to-address-group").hide();
			}
		});
		if (AJS.$("#customReplyToAddrCf").val()=="" || AJS.$("#customReplyToAddrCf").val()=="0") {
			AJS.$(".static-reply-to-address-group").show();
		} else {
			AJS.$(".static-reply-to-address-group").hide();
		}

		//reply-to personal
		AJS.$("#customReplyToPersonalCf").change(function(){
			var selectedVal=AJS.$(this).val();
			if (selectedVal==""|| selectedVal=="0")
			{
				AJS.$(".static-reply-to-personal-group").show();
			}
			else
			{
				AJS.$(".static-reply-to-personal-group").hide();
			}

		});
		if (AJS.$("#customReplyToPersonalCf").val()=="" || AJS.$("#customReplyToPersonalCf").val()=="0") {
			AJS.$(".static-reply-to-personal-group").show();
		} else {
			AJS.$(".static-reply-to-personal-group").hide();
		}
	}

	function hookRequireCommentToNotify()
	{
		AJS.$("#requireCommentToNotify").change(function() {
			if (AJS.$(this).is(":checked"))
			{
				//now show the blacklist/whitelist
				AJS.$(".require-comment-event-fields").closest('.field-group').show(250);
				//AJS.$(".require-comment-event-fields").closest('.field-group').attr('visibility','visible');
			}
			else
			{
				AJS.$(".require-comment-event-fields").closest('.field-group').hide();
				//AJS.$(".require-comment-event-fields").closest('.field-group').attr('visibility','hidden');
			}
		});

		if (AJS.$("#requireCommentToNotify").is(":checked") == false) {
			AJS.$(".require-comment-event-fields").closest('.field-group').hide();
		}
	}

	function hookNotifyMeEventsVisibility() {
		AJS.$("#notifyMeCondition").change(function() {
			if(AJS.$("#notifyMeCondition").val() === "forSelectedEvents"){
				AJS.$("#notifyMeEvents").closest(".field-group").show(250);
			}else{
				AJS.$("#notifyMeEvents").closest(".field-group").hide(250);
			}
		});
		AJS.$("#notifyMeCondition").change();
	}

	function hookInlineImageAttachmentVisibility() {
		AJS.$(".jemh-inline-image-enable").change(function() {
        AJS.$(".jemh-inline-image-enable").each(function() {
            if ($(this).is(":checked")) {
                AJS.$(".jemh-attach-inline-image").closest(".group").show(250);
                AJS.$(".jemh-attach-inline-image").attr("checked", true);
            } else {
                AJS.$(".jemh-attach-inline-image").removeAttr("checked");
                AJS.$(".jemh-attach-inline-image").closest(".group").hide(250);
            }
        });
		});

		AJS.$(".jemh-inline-image-enable").each(function() {
				if (!$(this).is(":checked")) {
            AJS.$(".jemh-attach-inline-image").removeAttr("checked");
            AJS.$(".jemh-attach-inline-image").closest(".group").hide(250);
				}
		});
	}

	function checkJSDRecipientOptionVis()
	{
		if ($('#useJsdParticipants').is(':checked'))
		{
			AJS.$(".jsdParticipantOptions").show("fast");
		}
		else
		{
			AJS.$(".jsdParticipantOptions").hide();
		}
	}

	function hookJSDRecipientOption()
	{
		checkJSDRecipientOptionVis();
		AJS.$("#useJsdParticipants").change(function()
		{
			checkJSDRecipientOptionVis();
		});
	}

	var customFields = [];

	function getKnownCFBy(value) {
		let ret;
		if (customFields != undefined && customFields.length > 0) {
			for (var i = 0; i < customFields.length; i++) {
				if (customFields[i].id == value) {
					ret = {id: customFields[i].id, name: customFields[i].name};
					break;
				}
			}
		}
		return ret;
	}

	if (AJS.$(".jemh-select-allCfs").length > 0) {
		AJS.$.ajax({
			url: baseUrl+"/rest/jemh/latest/api/config/customFields/"+ "?atl_token="+atlToken,
			timeout: 60000
		})
		.done(function(data) {
			customFields = data.list;
			AJS.$(".jemh-select-allCfs").auiSelect2({
				multiple: true,
				data: {results: customFields, text: 'name'},
				formatResult: function(item) { return item.name+' ('+item.id+')'; },
				formatSelection: function(item) { return item.name; },
				initSelection: function(element, callback) {
					var sel = [];
			        AJS.$(element.val().split(",")).each(function () {
			        	if (customFields != undefined) {
			        		let found =  getKnownCFBy(this);
			        		if (found) {
			        			sel.push(found);
			        		}
			        	}
			        });
			        element.val("");
			        callback(sel);
				}
			});
		})
		.fail(function(req,status,error) {
			console.error("JEMH failed to retrieve custom fields via REST");
		});
	}

	console.log('eventlistener.js init');
	hookFromAndReplyToCustomFieldSelects();
	hookJSDRecipientOption();
	hookRequireCommentToNotify();
	hookNotifyMeEventsVisibility();
	hookInlineImageAttachmentVisibility();

	AJS.$("#customerTemplates").change(function()
	{
		if (AJS.$('#customerTemplates').prop("checked") === true)
		{
			AJS.$(".jemh-checkall").prev().show();
			AJS.$('.jsd-issue-event-selectors, #jsd-specific-filter-misc-buttons, #jemh-jsd-filter-buttons-div').show("fast");
		} else {
			AJS.$(".jemh-checkall").prev().hide();
			AJS.$('.jsd-issue-event-selectors, #jsd-specific-filter-misc-buttons, #jemh-jsd-filter-buttons-div').hide();
		}
	});

	if (AJS.$('#customerTemplates').prop("checked") === true)
	{
		AJS.$('.jsd-issue-event-selectors').show();
		AJS.$('#jsd-specific-filter-misc-buttons').show();
		AJS.$('#jemh-jsd-filter-buttons-div').show();
	}
});
