AJS.$(document).ready(function () {
    console.log('user.js loaded');

    checkCreateUserOption(0);

    AJS.$("#createUsers").on("change", function (e) {
        checkCreateUserOption(500)
    });

    function checkCreateUserOption(showSpeed) {
        let createUsers = AJS.$("#createUsers").attr("checked");
        if (createUsers === "checked") {
            AJS.$(".userCreationOption").show(showSpeed);
        } else {
            AJS.$(".userCreationOption").hide(showSpeed);
        }
    }
       
   AJS.$("#createUsersIDFrom").on("change", function (e) {
		let speed = 250;
       	selectedCreateUserId(speed);
       	let createUserIdValue = AJS.$("#createUsersIDFrom").val();
       	if(createUserIdValue === "alternate"){
			AJS.$("#alternateIdProviderKey").val("javahollic-defaultid").change();
		}
    }); 
    
   AJS.$("#alternateIdProviderKey").on("change", function (e) {
		let speed = 250;
      	selectedAlternateIdProvider(speed);
    }); 
   
  	function selectedCreateUserId(hideSpeed) {
		let createUserIdValue = AJS.$("#createUsersIDFrom").val();
       	if(createUserIdValue === "alternate"){
			AJS.$("#alternateIdProviderField").show(hideSpeed);
		}
		else{
			AJS.$("#alternateIdProviderField").hide(hideSpeed);
			AJS.$("#ldapConfigIdsField").hide(hideSpeed);
			AJS.$("#ldapConfigIds").val(undefined).change();
			AJS.$("#alternateIdProviderField").val(undefined).change();
			AJS.$("#alternateIdProviderKey").val(undefined).change();
		}
	
	}
	
  	function selectedAlternateIdProvider(hideSpeed) {
		
		let selectedAlternateIdProviderKey = AJS.$('#alternateIdProviderKey').find(":selected").val();
		let includesLDAP = selectedAlternateIdProviderKey.includes("ldap");
		if (includesLDAP) {
			AJS.$("#ldapConfigIdsField").show(hideSpeed);
		}
		else {
			AJS.$("#ldapConfigIdsField").hide(hideSpeed);
			AJS.$("#ldapConfigIds").val(undefined).change(); 
		}
	}
   
   	function setupView() {
		let speed = 0;
		selectedCreateUserId(speed);
		selectedAlternateIdProvider(speed);	
	}
   
   setupView();
});
