print('Hello, World!\n');
print('This is an example script, showing the basics of how to use a scripted project mapping rule.\n');
print('The print method used here results in output when the script is evaluated during processing.');
print('This can be useful for debugging.\n');

print('For example, the context variable "message" is an object of ' + message.getClass());
print('The email subject is a String, which for the selected test case email is:\n' + subject);

if (jemhUtils.getCatchEmailAddress() !== null)
{
	print('\ncatchEmailAddress is ' + jemhUtils.getCatchEmailAddress().getAddress());
}
else
{
	print('\ncatchEmailAddress is NOT set in your Profile, so is not available here');
}

print('\nfromAddress is ' + fromAddress.getAddress());
for (i = 0; i < allAddresses.length; i++) {
    print('allAddresses #' + i + ' = ' + allAddresses[i].getAddress());
}

if (toAddresses) {
    for (i = 0; i < toAddresses.length; i++) {
        print('toAddresses #' + i + ' = ' + toAddresses[i].getAddress());
    }
}
if (ccAddresses) {
    for (i = 0; i < ccAddresses.length; i++) {
        print('ccAddresses #' + i + ' = ' + ccAddresses[i].getAddress());
    }
}
if (bccAddresses) {
    for (i = 0; i < bccAddresses.length; i++) {
        print('bccAddresses #' + i + ' = ' + bccAddresses[i].getAddress());
    }
}

//setting the below variable to true will instruct JEMH that this rule is a match
var isDemonstration = false;

if (isDemonstration) {
    print('\nSetting a Rule Match!');
    result.setMatch(true);

    //setting field values in  the resultMap
    print('\nSetting a label!');
    resultMap.put("labels", "hello-world");
    print('Setting the summary!');
    resultMap.put("summary", "This will be the final summary");
}
